import { Observable, PartialObserver as Listener, Subscription } from 'rxjs'
import { PushEvent } from './baseTypes'
export { Listener, Subscription }
export interface ObservableComponentBase {
    mount: Observable<any>
    unmount: Observable<any>
    fromEvent: <T>(
        eventName: string,
        valueTransformer?: (val: any) => T
    ) => Observable<T>
    pushEvent: PushEvent
    useEvent: <T>(
        eventName: string,
        seedValue?: T
    ) => [Observable<T>, (val: T) => any]
}
export interface Observe {
    observe: <T>(
        propName?: string,
        valueTransformer?: (val: any) => T
    ) => Observable<T>
}
export declare type ObservableComponent = Observe & ObservableComponentBase
export declare type Aperture<P, E, C = any> = (
    component: ObservableComponent,
    initialProps: P,
    initialContext?: C
) => Observable<E>
export declare const subscribeToSink: <T>(
    sink: Observable<T>,
    next: (val: T) => void,
    error?: (error: any) => void
) => Subscription
export declare const getObserve: <P>(
    getProp: any,
    data: any
) => <T>(propName?: any, valueTransformer?: any) => any
export declare const createComponent: <P>(
    getProp: any,
    dataObservable: any,
    pushEvent: PushEvent
) => ObservableComponent
